VERSION 5.00
Begin VB.UserControl SequenceDefinition 
   ClientHeight    =   6315
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6540
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   6315
   ScaleWidth      =   6540
   Begin VB.CheckBox chkUpperCase 
      Caption         =   "Sequence Name Upper Case"
      Height          =   255
      Left            =   240
      TabIndex        =   15
      TabStop         =   0   'False
      Top             =   600
      Width           =   2700
   End
   Begin VB.Frame fraComment 
      Caption         =   "Comment"
      Height          =   1845
      Left            =   120
      OLEDropMode     =   1  'Manual
      TabIndex        =   14
      Top             =   4200
      Width           =   6120
      Begin VB.TextBox txtComment 
         Height          =   1320
         Left            =   200
         MultiLine       =   -1  'True
         OLEDropMode     =   1  'Manual
         ScrollBars      =   2  'Vertical
         TabIndex        =   5
         TabStop         =   0   'False
         Top             =   240
         Width           =   5700
      End
   End
   Begin VB.CheckBox chkCyclic 
      Caption         =   "Cycle"
      Height          =   315
      Left            =   195
      TabIndex        =   13
      TabStop         =   0   'False
      Top             =   3720
      Width           =   960
   End
   Begin VB.TextBox txtCache 
      Height          =   315
      Left            =   1815
      MaxLength       =   38
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   12
      TabStop         =   0   'False
      Text            =   "100"
      Top             =   3285
      Width           =   3945
   End
   Begin VB.TextBox txtMaximum 
      Height          =   315
      Left            =   1800
      MaxLength       =   38
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   10
      TabStop         =   0   'False
      Top             =   2745
      Width           =   3945
   End
   Begin VB.TextBox txtMinimum 
      Height          =   315
      Left            =   1800
      MaxLength       =   38
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   2235
      Width           =   3945
   End
   Begin VB.TextBox txtIncrement 
      Height          =   315
      Left            =   1800
      MaxLength       =   38
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   6
      TabStop         =   0   'False
      Text            =   "1"
      Top             =   1740
      Width           =   3945
   End
   Begin VB.TextBox txtStartValue 
      Height          =   315
      Left            =   1800
      MaxLength       =   38
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   1245
      Width           =   3945
   End
   Begin VB.CheckBox chkCache 
      Caption         =   "Values to Cache"
      Height          =   315
      Left            =   195
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   3285
      Value           =   1  'Checked
      Width           =   1560
   End
   Begin VB.TextBox txtSequencename 
      Height          =   315
      Left            =   1800
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   200
      Width           =   3945
   End
   Begin VB.Label lblMaximum 
      Caption         =   "Maximum Value:"
      Height          =   255
      Left            =   195
      OLEDropMode     =   1  'Manual
      TabIndex        =   11
      Top             =   2775
      Width           =   1455
   End
   Begin VB.Label lblMinimum 
      Caption         =   "Minimum Value:"
      Height          =   255
      Left            =   195
      OLEDropMode     =   1  'Manual
      TabIndex        =   9
      Top             =   2280
      Width           =   1455
   End
   Begin VB.Label lblIncrement 
      Caption         =   "Increment By:"
      Height          =   255
      Left            =   195
      OLEDropMode     =   1  'Manual
      TabIndex        =   7
      Top             =   1785
      Width           =   1455
   End
   Begin VB.Label lblStartValue 
      Caption         =   "Start With:"
      Height          =   255
      Left            =   195
      OLEDropMode     =   1  'Manual
      TabIndex        =   4
      Top             =   1275
      Width           =   1455
   End
   Begin VB.Label lblSequencename 
      Caption         =   "Sequence Name:"
      Height          =   255
      Left            =   200
      OLEDropMode     =   1  'Manual
      TabIndex        =   2
      Top             =   240
      Width           =   1455
   End
   Begin VB.Menu mnuSequenceDefinition 
      Caption         =   "Sequence &Definition"
      NegotiatePosition=   2  'Middle
      Begin VB.Menu mnuCreateSequence 
         Caption         =   "&Create Sequence"
         Shortcut        =   {F8}
      End
      Begin VB.Menu mnuShowSQL 
         Caption         =   "Export to S&QL Dialog"
      End
   End
End
Attribute VB_Name = "SequenceDefinition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      SequenceDefinition.ctl
'
'========================================================================================
'
' responsible:    RalfS
'
' special area:   SQLStudio
'
' description:    Control for creating a new sequence definition.
'
'========================================================================================

Option Explicit

'==============================================================================
' Constant definitions
'==============================================================================
Const MODULE_NAME = "SQLStudio.SequenceDefinitionControl"
Const MX_COLUMN_NAME = 256
Const MIN_UINT = 0
Const MAX_UINT = 4294967294#
Const MIN_INT = -2147483647
Const MAX_INT = 2147483647

'==============================================================================
' Event declarations
'==============================================================================
Event CloseMe()

Event ShowSQLInDirectSQL(oSFC As SQLStudioMan.storedFileContent)
'==============================================================================
' Private members
'==============================================================================
Private m_lParentWnd                As Long
Private m_oGlobalInfo               As SQLStudioMan.globalInfo
Private m_oConnection               As SQLStudioDBLayer.connection
Private m_sTablename                As String
Private m_lOldWidth                 As Long
Private m_lOldHeight                As Long
Private m_bLoaded                   As Boolean

Private m_lAppVersion               As Long

Private m_oSQLStatement             As New BreakStatement

Private m_bUpperCase                As Boolean
'=========================================================================================
'    property:      AppVersion (Let)
'    description:   Sets the private member m_lAppVersion to the given value.
'    arguments:     [in] NewAppVersion - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let appVersion(NewAppVersion As Long)
    On Error GoTo errP_LET_AppVersion

    Const FUNCTION_NAME = "p_let appVersion"
    
    m_lAppVersion = NewAppVersion
    
    Exit Property
    
errP_LET_AppVersion:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'==============================================================================
' Set the private member m_lParentWnd to the given value
'==============================================================================
Public Property Let callingWindow(hWnd As Long)
    On Error GoTo errP_LET_CallingWindow

    Const FUNCTION_NAME = "p_LET callingWindow"

    m_lParentWnd = hWnd

    Exit Property

errP_LET_CallingWindow:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Create a new instance of the globalInfo class and store it in the private
' member m_oGlobalInfo.
'==============================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "p_SET globalInfo"
    

    Set m_oGlobalInfo = newGlobalInfo
    
    '--------------------------------------------------------------------------
    ' Initializations
    '--------------------------------------------------------------------------
    'check initial value of uppercase value
    If m_oGlobalInfo.userProfile.identifiersCaseSensitiv Then
        chkUpperCase.value = vbUnchecked
        m_bUpperCase = False
    Else
        chkUpperCase.value = vbChecked
        m_bUpperCase = True
    End If
    
    Exit Property

errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Create a new instance of the Connection class and store it in the
' private member m_oConnection.
'==============================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "p_SET Connection"
    
    Set m_oConnection = NewConnection
    
    Exit Property
    
errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Get the value of the private member m_oConnection
'==============================================================================
Public Property Get connection() As SQLStudioDBLayer.connection
    On Error GoTo errP_Get_Connection

    Const FUNCTION_NAME = "G_GET Connection"
    
    Set connection = m_oConnection
    
    Exit Property
    
errP_Get_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Get the value of the parent control.
'==============================================================================
Public Property Get parentControl() As Object
    On Error GoTo errP_Get_ParentControl

    Const FUNCTION_NAME = "G_GET parentControl"

    Set parentControl = Parent

    Exit Property

errP_Get_ParentControl:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Handle the Click event for the Cache checkbox.
'==============================================================================
Private Sub chkCache_Click()
    On Error GoTo errChkCache_Click
    
    Const FUNCTION_NAME = "chkCache_Click"
    
    If chkCache.value = 1 Then
        txtCache.Enabled = True
    Else
        txtCache.Enabled = False
    End If
    
    Exit Sub
    
errChkCache_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Cache checkbox.
'==============================================================================
Private Sub chkCache_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkCache_KeyDown
    
    Const FUNCTION_NAME = "chkCache_KeyDown"
    
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        If chkCache.value = 0 Then
            chkCyclic.SetFocus
        Else
            txtCache.SetFocus
            txtCache.selStart = 0
            txtCache.SelLength = Len(txtCache.Text)
        End If
    Else
        txtMaximum.SetFocus
        txtMaximum.selStart = 0
        txtMaximum.SelLength = Len(txtMaximum.Text)
    End If
    
    Exit Sub
    
errChkCache_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub chkCache_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkCache_MouseUp
    
    Const FUNCTION_NAME = "chkCache_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errChkCache_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkCache_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errChkCache_OLEDragOver
    
    Const FUNCTION_NAME = "chkCache_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errChkCache_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Cyclic checkbox.
'==============================================================================
Private Sub chkCyclic_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkCyclic_KeyDown
    
    Const FUNCTION_NAME = "chkCyclic_KeyDown"
    
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        txtComment.SetFocus
        txtComment.selStart = 0
        txtComment.SelLength = Len(txtComment.Text)
    Else
        txtCache.SetFocus
    End If
    
    Exit Sub
    
errChkCyclic_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub chkCyclic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkCyclic_MouseUp
    
    Const FUNCTION_NAME = "chkCyclic_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errChkCyclic_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkCyclic_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errChkCyclic_OLEDragOver
    
    Const FUNCTION_NAME = "chkCyclic_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errChkCyclic_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub chkUpperCase_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkCache_KeyDown
    
    Const FUNCTION_NAME = "chkCache_KeyDown"
    
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
         txtStartValue.SetFocus
         txtStartValue.selStart = 0
         txtStartValue.SelLength = Len(txtStartValue.Text)
    Else
        txtSequencename.SetFocus
        txtSequencename.selStart = 0
        txtSequencename.SelLength = Len(txtComment.Text)
    End If
    
    Exit Sub
    
errChkCache_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblIncrement_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblIncrement_MouseUp
    
    Const FUNCTION_NAME = "lblIncrement_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblIncrement_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblIncrement_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblIncrement_OLEDragOver
    
    Const FUNCTION_NAME = "lblIncrement_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblIncrement_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblMaximum_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblMaximum_MouseUp
    
    Const FUNCTION_NAME = "lblMaximum_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblMaximum_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblMaximum_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblMaximum_OLEDragOver
    
    Const FUNCTION_NAME = "lblMaximum_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblMaximum_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblMinimum_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblMinimum_MouseUp
    
    Const FUNCTION_NAME = "lblMinimum_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblMinimum_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblMinimum_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblMinimum_OLEDragOver
    
    Const FUNCTION_NAME = "lblMinimum_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblMinimum_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblSequencename_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblSequencename_MouseUp
    
    Const FUNCTION_NAME = "lblSequencename_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblSequencename_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblSequencename_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblSequencename_OLEDragOver
    
    Const FUNCTION_NAME = "lblSequencename_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblSequencename_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblStartValue_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblStartValue_MouseUp
    
    Const FUNCTION_NAME = "lblStartValue_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblStartValue_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblStartValue_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblStartValue_OLEDragOver
    
    Const FUNCTION_NAME = "lblStartValue_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblStartValue_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the Click event for the table menu item "Create Sequence".
'==============================================================================
Private Sub mnuCreateSequence_Click()
    On Error GoTo errMnuCreateSequence_Click
    
    Const FUNCTION_NAME = "mnuCreateSequence_Click"
    
    execute
    
    Exit Sub
    
errMnuCreateSequence_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' When the menu "Show SQL" was clicked, compose an SQL statement with
' the currently entered values.
'==============================================================================
Private Sub mnuShowSQL_Click()
    On Error GoTo errMnuShowSQL_Click
    
    Const FUNCTION_NAME = "mnuShowSQL_Click"
    
    Dim sStatement As String
    
    sStatement = composeSQLStatement
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no Sequence name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be displayed in a new window.
    '--------------------------------------------------------------------------
    Select Case sStatement
    Case ""
        MsgBox LoadResString(410), vbExclamation, LoadResString(409)
    Case "Start"
        MsgBox LoadResString(414), vbExclamation, LoadResString(412)
    Case "MinMax"
        MsgBox LoadResString(415), vbExclamation, LoadResString(412)
    Case Else
        showSQLStatement (sStatement)
    End Select
    
    Exit Sub
    
errMnuShowSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Cache field.
'==============================================================================
Private Sub txtCache_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtCache_KeyDown
    
    Const FUNCTION_NAME = "txtCache_KeyDown"
    
    If txtSequencename.Locked = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        chkCyclic.SetFocus
    Else
        chkCache.SetFocus
    End If
    
    Exit Sub
    
ErrtxtCache_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Handle the MouseUp event for the Cache field.
'==============================================================================
Private Sub txtCache_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtCache_MouseUp
    
    Const FUNCTION_NAME = "txtCache_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtCache_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtCache_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errChkCache_OLEDragOver
    
    Const FUNCTION_NAME = "txtCache_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errChkCache_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Comment field.
'==============================================================================
Private Sub txtComment_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtComment_KeyDown
    
    Const FUNCTION_NAME = "txtComment_KeyDown"
    
    If txtSequencename.Locked = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        txtSequencename.SetFocus
        txtSequencename.selStart = 0
        txtSequencename.SelLength = Len(txtSequencename.Text)
    Else
        chkCyclic.SetFocus
    End If
    
    Exit Sub
    
ErrtxtComment_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyPress event for the comment textbox.
'==============================================================================
Private Sub txtComment_KeyPress(KeyAscii As Integer)
    On Error GoTo ErrtxtComment_KeyPress
    
    Const FUNCTION_NAME = "txtComment_KeyPress"
    
    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyAscii = 9 Then KeyAscii = 0
    
    Exit Sub
    
ErrtxtComment_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub fraComment_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraComment_MouseUp
    
    Const FUNCTION_NAME = "fraComment_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrfraComment_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtComment_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtComment_OLEDragOver
    
    Const FUNCTION_NAME = "txtComment_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtComment_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Handle the KeyDown event for the Increment field.
'==============================================================================
Private Sub txtIncrement_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtIncrement_KeyDown
    
    Const FUNCTION_NAME = "txtIncrement_KeyDown"
    
    If txtSequencename.Locked = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        txtMinimum.SetFocus
        txtMinimum.selStart = 0
        txtMinimum.SelLength = Len(txtMinimum.Text)
    Else
        txtStartValue.SetFocus
        txtStartValue.selStart = 0
        txtStartValue.SelLength = Len(txtStartValue.Text)
    End If
    
    Exit Sub
    
ErrtxtIncrement_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Handle the MouseUp event for the Increment field.
'==============================================================================
Private Sub txtIncrement_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtIncrement_MouseUp
    
    Const FUNCTION_NAME = "txtIncrement_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtIncrement_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtIncrement_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtIncrement_OLEDragOver
    
    Const FUNCTION_NAME = "txtIncrement_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtIncrement_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Maximum field.
'==============================================================================
Private Sub txtMaximum_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtMaximum_KeyDown
    
    Const FUNCTION_NAME = "txtMaximum_KeyDown"
    
    If txtSequencename.Locked = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        chkCache.SetFocus
    Else
        txtMinimum.SetFocus
        txtMinimum.selStart = 0
        txtMinimum.SelLength = Len(txtMinimum.Text)
    End If
    
    Exit Sub
    
ErrtxtMaximum_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Handle the MouseUp event for the Maximum field.
'==============================================================================
Private Sub txtMaximum_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtMaximum_MouseUp
    
    Const FUNCTION_NAME = "txtMaximum_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtMaximum_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtMaximum_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtMaximum_OLEDragOver
    
    Const FUNCTION_NAME = "txtMaximum_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtMaximum_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Minimum field.
'==============================================================================
Private Sub txtMinimum_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtMinimum_KeyDown
    
    Const FUNCTION_NAME = "txtMinimum_KeyDown"
    
    If txtSequencename.Locked = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        txtMaximum.SetFocus
        txtMaximum.selStart = 0
        txtMaximum.SelLength = Len(txtMaximum.Text)
    Else
        txtIncrement.SetFocus
        txtIncrement.selStart = 0
        txtIncrement.SelLength = Len(txtIncrement.Text)
    End If
    
    Exit Sub
    
ErrtxtMinimum_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Handle the MouseUp event for the Minimum field.
'==============================================================================
Private Sub txtMinimum_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtMinimum_MouseUp
    
    Const FUNCTION_NAME = "txtMinimum_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtMinimum_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtMinimum_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtMinimum_OLEDragOver
    
    Const FUNCTION_NAME = "txtMinimum_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtMinimum_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Sequence Name field.
'==============================================================================
Private Sub txtSequencename_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtSequencename_KeyDown
    
    Const FUNCTION_NAME = "txtSequencename_KeyDown"
    
    If txtSequencename.Locked = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        chkUpperCase.SetFocus
    Else
        txtComment.SetFocus
        txtComment.selStart = 0
        txtComment.SelLength = Len(txtComment.Text)
    End If
    
    Exit Sub
    
ErrtxtSequencename_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub txtSequencename_KeyPress(KeyAscii As Integer)
 On Error GoTo ErrtxtSequencename_KeyPress
    
    Const FUNCTION_NAME = "txtSequencename_KeyPress"

    If m_bUpperCase Then
        KeyAscii = Asc(UCase(Chr(KeyAscii)))
    End If
    
    Exit Sub
    
ErrtxtSequencename_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Handle the MouseUp event for the Sequence Name field.
'==============================================================================
Private Sub txtSequencename_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtSequencename_MouseUp
    
    Const FUNCTION_NAME = "txtSequencename_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtSequencename_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtSequencename_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtSequencename_OLEDragOver
    
    Const FUNCTION_NAME = "txtSequencename_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtSequencename_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Start Value field.
'==============================================================================
Private Sub txtStartValue_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtStartValue_KeyDown
    
    Const FUNCTION_NAME = "txtStartValue_KeyDown"
    
    If txtSequencename.Locked = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        txtIncrement.SetFocus
        txtIncrement.selStart = 0
        txtIncrement.SelLength = Len(txtIncrement.Text)
    Else
        chkUpperCase.SetFocus
    End If
    
    Exit Sub
    
ErrtxtStartValue_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Handle the MouseUp event for the Start Value field.
'==============================================================================
Private Sub txtStartValue_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtStartValue_MouseUp
    
    Const FUNCTION_NAME = "txtStartValue_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtStartValue_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtStartValue_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtStartValue_OLEDragOver
    
    Const FUNCTION_NAME = "txtStartValue_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtStartValue_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Initialize the user control.
'==============================================================================
Private Sub UserControl_Initialize()
    On Error GoTo errUserControl_Initialize
    
    Const FUNCTION_NAME = "UserControl_Initialize"
    
    Dim i As Integer
    
    m_bLoaded = False
    
    '--------------------------------------------------------------------------
    ' Initialization of the strings.
    '--------------------------------------------------------------------------
    lblSequencename.Caption = LoadResString(400)
    lblStartValue.Caption = LoadResString(401)
    lblIncrement.Caption = LoadResString(402)
    lblMinimum.Caption = LoadResString(403)
    lblMaximum.Caption = LoadResString(404)
    chkCache.Caption = LoadResString(405)
    chkCyclic.Caption = LoadResString(408)
    
    
    m_oSQLStatement.addComment "//"
    m_oSQLStatement.addComment "--"
    
    m_lAppVersion = 72200
    
    m_bUpperCase = True
    
    Exit Sub
    
errUserControl_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseMove event for the user control.
'==============================================================================
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_MouseMove
    
    Const FUNCTION_NAME = "UserControl_MouseMove"
    
    UserControl.MousePointer = vbArrow
    
    Exit Sub
    
errUserControl_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event for the user control.
'==============================================================================
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_MouseUp
    
    Const FUNCTION_NAME = "UserControl_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errUserControl_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errUserControl_OLEDragOver
    
    Const FUNCTION_NAME = "UserControl_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errUserControl_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the resize event for the control.
'==============================================================================
Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Compose the CREATE statement with the values currently entered in the widgets.
'==============================================================================
Private Function composeSQLStatement() As String
    On Error GoTo errComposeSQLStatement

    Const FUNCTION_NAME = "composeSQLStatement"
    
    Dim sSQL           As String
    Dim i              As Integer
    Dim sSeperator     As String
    Dim sPublic        As String
    
    sSeperator = vbNewLine + "//" + vbNewLine
    
    '--------------------------------------------------------------------------
    ' Check if a Sequence name was given. If not, an empty string will be
    ' returned.
    '--------------------------------------------------------------------------
    If txtSequencename.Text = "" Then
        composeSQLStatement = ""
        Exit Function
    End If
    
    '--------------------------------------------------------------------------
    ' Check if the maximum value is greater then the minimum value.
    '--------------------------------------------------------------------------
    If txtMinimum.Text <> "" And txtMaximum.Text <> "" Then
        If CSng(txtMinimum.Text) > CSng(txtMaximum.Text) Then
            composeSQLStatement = "MinMax"
            Exit Function
        End If
    End If
    
    '--------------------------------------------------------------------------
    ' Check if the start value is between the minimum and the maximum value.
    '--------------------------------------------------------------------------
    If txtStartValue.Text <> "" And txtMinimum.Text <> "" Then
        If CSng(txtStartValue.Text) < CSng(txtMinimum.Text) Then
            composeSQLStatement = "Start"
            Exit Function
        End If
    End If
    
    If txtStartValue.Text <> "" And txtMaximum.Text <> "" Then
        If CSng(txtStartValue.Text) > CSng(txtMaximum.Text) Then
            composeSQLStatement = "Start"
            Exit Function
        End If
    End If
    
    '----------------------------------------------------------------------
    ' Create the CREATE SEQUENCE clause with the entered sequence name.
    '----------------------------------------------------------------------
    sSQL = vbNewLine + "CREATE SEQUENCE "
    
    If m_bUpperCase Then
    
        sSQL = sSQL + Chr(34) + UCase(txtSequencename.Text) + Chr(34)
    Else
        sSQL = sSQL + Chr(34) + txtSequencename.Text + Chr(34)
    End If
    
    If txtIncrement.Text <> "" Then _
        sSQL = sSQL + " INCREMENT BY " + txtIncrement.Text
    
    If txtStartValue.Text <> "" Then _
        sSQL = sSQL + " START WITH " + txtStartValue.Text
    
    If txtMinimum.Text <> "" Then
        sSQL = sSQL + " MINVALUE " + txtMinimum.Text
    Else
        sSQL = sSQL + " NOMINVALUE"
    End If
    
    If txtMaximum.Text <> "" Then
        sSQL = sSQL + " MAXVALUE " + txtMaximum.Text
    Else
        sSQL = sSQL + " NOMAXVALUE"
    End If
    
    If chkCyclic.value = 0 Then
        sSQL = sSQL + " NOCYCLE"
    Else
        sSQL = sSQL + " CYCLE"
    End If
    
    If chkCache.value <> 0 And txtCache.Text <> "" Then
        sSQL = sSQL + " CACHE " + txtCache.Text
    Else
        sSQL = sSQL + " NOCACHE"
    End If
    
    '----------------------------------------------------------------------
    ' Append the SQL statement for the entered comment.
    '----------------------------------------------------------------------
    If txtComment.Text <> "" Then
        sSQL = sSQL + sSeperator + "COMMENT ON SEQUENCE "
        If m_bUpperCase Then
            sSQL = sSQL + Chr(34) + UCase(txtSequencename.Text) + Chr(34)
        Else
            sSQL = sSQL + Chr(34) + txtSequencename.Text + Chr(34)
        End If
        sSQL = sSQL + " IS '" + m_oComFunc.convertStringForCharCol(txtComment.Text, True) + "'"
    End If
    
    composeSQLStatement = sSQL
    
    Exit Function
    
errComposeSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Execute the resulting SQL statement.
'==============================================================================
Public Function execute()
    On Error GoTo errExecute
    
    Const FUNCTION_NAME = "execute"
    
    Dim sSQL            As String
    Dim oResult         As SQLStudioDBLayer.Result
    
    '--------------------------------------------------------------------------
    ' Generate the SQL statements depending on the input of the user.
    '--------------------------------------------------------------------------
    sSQL = composeSQLStatement
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no Sequence name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be sent to the database.
    '--------------------------------------------------------------------------
    Select Case sSQL
    Case ""
        MsgBox LoadResString(410), vbExclamation, LoadResString(409)
    Case "Start"
        MsgBox LoadResString(414), vbExclamation, LoadResString(412)
    Case "MinMax"
        MsgBox LoadResString(415), vbExclamation, LoadResString(412)
    Case Else
        '----------------------------------------------------------------------
        ' Initialize the SQL statement object
        '----------------------------------------------------------------------
        Set m_oSQLStatement.connection = m_oConnection
        m_oSQLStatement.resultMode = sapdbSimpleMode
        m_oSQLStatement.callingWindow = m_lParentWnd
        m_oSQLStatement.statement = sSQL
        
        '----------------------------------------------------------------------
        ' Execute each SQL statement of the given string.
        '----------------------------------------------------------------------
        While Not m_oSQLStatement.eos And _
              Len(Trim$(m_oSQLStatement.currentStatement)) > 0 And _
              Trim$(m_oSQLStatement.currentStatement) <> vbCrLf
            If m_oSQLStatement.execute(oResult, Internal) Then
                m_oSQLStatement.nextStatement
            Else
                m_oConnection.Error.showError
                m_oSQLStatement.statement = "ROLLBACK"
                m_oSQLStatement.execute oResult, Internal
                Exit Function
            End If
        Wend
                
        m_oSQLStatement.statement = "COMMIT"
        m_oSQLStatement.execute oResult, Internal
        
        '----------------------------------------------------------------------
        ' Display a feedback messagebox.
        '----------------------------------------------------------------------
        MsgBox LoadResString(413), vbExclamation, LoadResString(412)
    
        RaiseEvent CloseMe
    End Select
    
    Exit Function
    
errExecute:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Load the definition of a given sequence.
'==============================================================================
Public Function loadSequenceDefinition(sName As String, sOwner As String)
    On Error GoTo errLoadSequenceDefinition

    Const FUNCTION_NAME = "loadSequenceDefinition"
    
    Dim s               As String
    Dim sql             As String
    Dim pos             As Integer
    Dim sStatement      As String
    Dim oResult         As New SQLStudioDBLayer.Result
    
    Set oResult.connection = m_oConnection
    
    '--------------------------------------------------------------------------
    ' Set the sequence name.
    '--------------------------------------------------------------------------
    txtSequencename.Text = sName
    
    '--------------------------------------------------------------------------
    ' Load the sequence definition.
    '--------------------------------------------------------------------------
    sql = "SELECT min_value,max_value,increment_by,cycle_flag,cache_size,comment,last_number FROM sequences WHERE sequence_name = '" + m_oComFunc.convertStringForCharCol(sName, True) + "' AND owner = '" + m_oComFunc.convertStringForCharCol(sOwner, True) + "'"
    If Not oResult.openResult(sql, Internal) Then Exit Function
    If oResult.noRows Then Exit Function
    If Not oResult.fetch() Then Exit Function
    If Not oResult.GetData() Then Exit Function

    txtMinimum.Text = oResult.Columns(1).colValue
    txtMaximum.Text = oResult.Columns(2).colValue
    txtIncrement.Text = oResult.Columns(3).colValue
    
    If oResult.Columns(4).colValue = "Y" Then
        chkCyclic.value = 1
    Else
        chkCyclic.value = 0
    End If
    
    If oResult.Columns(5).colValue <> 20 Then
        chkCache.value = 1
        txtCache.Text = oResult.Columns(5).colValue
    Else
        chkCache.value = 0
        txtCache.Text = ""
    End If
    If oResult.Columns(6).colValue <> oResult.representationOfNullValue Then _
        txtComment.Text = oResult.Columns(6).colValue
        
    'see PTS 1117123
    txtStartValue.Text = oResult.Columns(7).colValue
    lblStartValue = LoadResString(511)
    
    '--------------------------------------------------------------------------
    ' Disable the GUI.
    '--------------------------------------------------------------------------
    txtSequencename.Locked = True
    txtStartValue.Locked = True
    txtIncrement.Locked = True
    txtMinimum.Locked = True
    txtMaximum.Locked = True
    txtCache.Locked = True
    txtComment.Locked = True
    chkCache.Enabled = False
    chkCyclic.Enabled = False
    mnuCreateSequence.Enabled = False
    chkUpperCase.Enabled = False
    
    Exit Function
    
errLoadSequenceDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Resize the single widgets according to the enclosing form.
'==============================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    'Exit Sub
    
    '--------------------------------------------------------------------------
    ' Recalculate the new horizontal dimensions only if the width of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldWidth <> UserControl.ScaleWidth Then
        txtSequencename.Width = UserControl.ScaleWidth - txtSequencename.Left - 250
        txtCache.Width = txtSequencename.Width
        txtStartValue.Width = txtSequencename.Width
        txtIncrement.Width = txtSequencename.Width
        txtMinimum.Width = txtSequencename.Width
        txtMaximum.Width = txtSequencename.Width
        fraComment.Width = UserControl.ScaleWidth - 250
        txtComment.Width = fraComment.Width - 400
        m_lOldWidth = UserControl.ScaleWidth
    End If
        
    '--------------------------------------------------------------------------
    ' Recalculate the new vertical dimensions only if the height of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldHeight <> UserControl.ScaleHeight Then
        fraComment.Height = m_oComFunc.Max(20, UserControl.ScaleHeight - fraComment.top - 150)
        txtComment.Height = m_oComFunc.Max(10, fraComment.Height - 450)
        m_lOldHeight = UserControl.ScaleHeight
    End If
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Show the resulting SQL statement in a separate window.
'==============================================================================
Private Sub showSQLStatement(sStatement As String)
    On Error GoTo errShowSQLStatement

    Const FUNCTION_NAME = "showSQLStatement"
        
    Dim oSFC As New SQLStudioMan.storedFileContent
    
    oSFC.sqlData = sStatement
    'the saved object has to have actual version numbers
    oSFC.appVersion = m_lAppVersion
    oSFC.Version = m_lAppVersion
    oSFC.storedIcon = cmStoredDSQL
    
    oSFC.FileName = ""
    
    RaiseEvent ShowSQLInDirectSQL(oSFC)
    
    Exit Sub
    
errShowSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Function checkDragObject(Effect As Long)
    On Error GoTo errCheckDragObject

    Const FUNCTION_NAME = "checkDragObject"
        
    Dim oDragObject     As Object
    
    For Each oDragObject In m_oGlobalInfo.dragObjects
        '--------------------------------------------------------------------------
        '   if a sql studio om is droped leave sub
        '--------------------------------------------------------------------------
        If TypeOf oDragObject Is SQLStudioMan.storedFileContent Then _
            Effect = Effect = vbDropEffectNone
        
    Next
    
    Exit Function
    
errCheckDragObject:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub chkUpperCase_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 On Error GoTo errchkUpperCase_MouseUp
    
    Const FUNCTION_NAME = "chkUpperCase_MouseUp"
    
    Select Case Button
    Case vbRightButton:
        PopupMenu mnuSequenceDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errchkUpperCase_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkUpperCase_Click()
 On Error GoTo ErrchkUpperCase_Click
    
    Const FUNCTION_NAME = "chkUpperCase_Click"
    
    Dim i As Integer
    
    If chkUpperCase.value = vbChecked Then
    
        txtSequencename = UCase(txtSequencename)
        
        m_bUpperCase = True
    Else
        m_bUpperCase = False
    End If
    
    Exit Sub
    
ErrchkUpperCase_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
